﻿using UnityEngine;
using HarmonyLib;
using I2.Loc;
using System.Collections.Generic;

public class SwitchResource : Mod
{
    public void Start()
    {

        var language = new LanguageSourceData()
        {
            mDictionary = new Dictionary<string, TermData>
            {
                ["CraftingSub/Resources"] = new TermData() { Languages = new[] { "Resources" } }
            },
            mLanguages = new List<LanguageData> { new LanguageData() { Code = "en", Name = "English" } }
        };
        LocalizationManager.Sources.Add(language);


        SetRecipe(ItemManager.GetItemByName("Plank"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Plastic"), ItemManager.GetItemByName("Thatch") }, 10),
        }, CraftingCategory.Resources, 5, true, "Resources", 0);

        SetRecipe(ItemManager.GetItemByName("Plastic"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Plank"), ItemManager.GetItemByName("Thatch") }, 10),
        }, CraftingCategory.Resources, 5, true, "Resources", 1);

        SetRecipe(ItemManager.GetItemByName("Thatch"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Plank"), ItemManager.GetItemByName("Plastic") }, 10),
        }, CraftingCategory.Resources, 5, true, "Resources", 2);

        SetRecipe(ItemManager.GetItemByName("Scrap"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("MetalIngot") }, 1),
        }, CraftingCategory.Resources, 5, true, "Resources", 3);


        Log("Mod Switch Resourse has been loaded!");
    }

    public void OnModUnload()
    {
        Debug.Log("Mod Switch Resource has been unloaded!");
    }


    public static void SetRecipe( Item_Base item, CostMultiple[] cost, CraftingCategory category = CraftingCategory.Resources, int amountToCraft = 1, bool learnedFromBeginning = true, string subCategory = null, int subCatergoryOrder = 0)
    {
        Traverse recipe = Traverse.Create(item.settings_recipe);
        recipe.Field("craftingCategory").SetValue(category);
        recipe.Field("amountToCraft").SetValue(amountToCraft);
        recipe.Field("learnedFromBeginning").SetValue(learnedFromBeginning);
        recipe.Field("subCategory").SetValue(subCategory);
        recipe.Field("subCatergoryOrder").SetValue(subCatergoryOrder);
        item.settings_recipe.NewCost = cost;
    }
}